#!/usr/bin/perl

#
# Use this program to automatically create the C table that lists the modules that are going to be
# linked statically to ScriptBasic. Do not edit the created C file, rather maintain one or more
# linkedmodules.def file and create one or more linkedmodules.c file
#

$InputFile = shift;
$OutputFile = shift;

unless( open(F,$InputFile) ){
  print "Usage: perl moduletablemaker.pl linkedmodules.def linkedmodules.c\n";
  exit;
  }

open(OUT,">$OutputFile") or die "Cannot open output file $OutputFile";

print OUT <<END;
/* FILE: $OutputFile

This file was automatically created by the program moduletablemaker.pl

DO NOT EDIT THIS FILE!!!

Rather edit the file $InputFile that is the source 

*/
#include <stdio.h>
#include "basext.h"

END

while( <F> ){
  chomp;
  next if /^\s*\#/;
  next if /^\s*$/;
  @words = split /\s+/;
  push @ModuleList, $words[0];
  }


for $module (@ModuleList ){
  print OUT "extern SLFST ",uc($module),"_SLFST[];\n"
  }

print OUT "MODLIST StaticallyLinkedModules[] ={\n";
for $module (@ModuleList ){
  print OUT "  {\"$module\" , (void *)", uc($module),"_SLFST },\n"
  }

close F;
print OUT "  { NULL, NULL },\n";
print OUT "  };\n";
close OUT;
