#! /usr/bin/perl

# Create mkzip.cmd that creates a ZIP file from the ScriptBasic sources.

# You may think that this is a simple
#
#             wzzip -r scriba.zip *
#
# but this is more than that. When the zipfile is created the directory
# may not be fresh. There can be a lot of generated garbage that is not
# part of the source. This script reads the CV Entries files and creates
# mktar.cmd that puts exactly those files into the ZIP archive that are source
# files.

open(BUILD,"build.txt") or die "Can not read build number";
$BUILD = <BUILD>;
close BUILD;
chomp $BUILD;

open(VERSION,"version.txt") or die "Can not read version";
$VERSION = <VERSION>;
close VERSION;
chomp $VERSION;

$InstallDirectory = shift;
$InstallDirectory = "T:\\ScriptBasic\\" unless defined $InstallDirectory;

sub AddDirToZip {
  my $dir = shift;

  open(IN,"$dir/CVS/Entries") or die "Can not open CV/Entries";
  my @lines = <IN>;
  close IN;
  for my $L (@lines){
    if( $L =~ m{^/(.*?)/} ){
      my $sfn = "$dir\\$1";
      $sfn =~ s/^\.\\//;
      print ZIP "$sfn\n";
      }elsif( $L =~ m{^D/(.*?)/} ){
      AddDirToZip("$dir\\$1");
      }elsif( $L =~ m{^D\s*$} ){
      }else{
      print "Invalid line in $dir/CVS/Entries:\n>>> $L\n"
      }
    }
  }

open(ZIP,">mkzip.cmd") or die "Can not write mkzip.cmd";
print ZIP <<END;
REM  FILE: mkzip
REM
REM This file was generated by scriba-zip.pl
REM The program that created this file searched the
REM CVS/Entries files for CV file entries and added the
REM entries to this file to create the source ZIP for
REM ScriptBasic
REM

REM First of all delete the ZIP file if it exists
del scriba-v${VERSION}b${BUILD}-source.zip

wzzip -a -ex -P scriba-v${VERSION}b${BUILD}-source.zip \@mkzip.lst
wzzip -a -ex -P -r scriba-v${VERSION}b${BUILD}-bin.zip ${InstallDirectory}*
wzzip -a -ex -P scriba-v${VERSION}b${BUILD}-exe.zip sbsetup\\setup.exe sbsetup\\sbcab.bin
wzzip -a -ex -P -r chm-v${VERSION}b${BUILD}-bin.zip ${InstallDirectory}doc\\*.chm
wzzip -a -ex -P -r text-v${VERSION}b${BUILD}-bin.zip ${InstallDirectory}doc\\*.texi
wzzip -a -ex -P -r pdf-v${VERSION}b${BUILD}-bin.zip ${InstallDirectory}doc\\*.pdf
wzzip -a -ex -P -r html-v${VERSION}b${BUILD}-bin.zip ${InstallDirectory}doc\\*.html
END
close ZIP;
open(ZIP,">mkzip.lst") or die "Can not write mkzip.lst";
print ZIP <<END;
; FILE: mkzip.lst
; This file was generated by scriba-zip.pl
; do not edit this file

END

&AddDirToZip('.');

close ZIP;
